/* $Id: los.c,v 1.3 2010/03/04 22:38:21 oohara Exp $ */

#include <stdio.h>
/* abs */
#include <stdlib.h>

#include "world.h"
#include "dungeon.h"

#include "los.h"

/* return 1 (true) or 0 (false) */
int
has_los(world *wp, int ax, int ay, int bx, int by)
{
  int longer_dx;
  int longer_dy;
  int longer_abs;
  int shorter_dx;
  int shorter_dy;
  int shorter_abs;
  int i;
  int x;
  int y;
  int j0;
  int blocked_j_low;
  int blocked_j_high;

  if (wp == NULL)
    return 0;
  if ((ax < 0) || (ax >= wp->size_x))
    return 0;
  if ((ay < 0) || (ay >= wp->size_y))
    return 0;
  if ((bx < 0) || (bx >= wp->size_x))
    return 0;
  if ((by < 0) || (by >= wp->size_y))
    return 0;

  if ((abs(ax - bx) <= 1) && (abs(ay - by) <= 1))
    return 1;

  if (abs(ax - bx) >= abs(ay - by))
  {
    if (ax < bx)
    {
      longer_dx = 1;
      longer_dy = 0;
    }
    else
    {
      longer_dx = -1;
      longer_dy = 0;
    }
    longer_abs = abs(ax - bx);
    if (ay < by)
    {  
      shorter_dx = 0;
      shorter_dy = 1;
    }
    else if (ay > by)
    {  
      shorter_dx = 0;
      shorter_dy = -1;
    }
    else
    {  
      shorter_dx = 0;
      shorter_dy = 0;
    }
    shorter_abs = abs(ay - by);
  }
  else
  {
    if (ay < by)
    {
      longer_dx = 0;
      longer_dy = 1;
    }
    else
    {
      longer_dx = 0;
      longer_dy = -1;
    }
    longer_abs = abs(ay - by);
    if (ax < bx)
    {  
      shorter_dx = 1;
      shorter_dy = 0;
    }
    else if (ax > bx)
    {  
      shorter_dx = -1;
      shorter_dy = 0;
    }
    else
    {  
      shorter_dx = 0;
      shorter_dy = 0;
    }
    shorter_abs = abs(ax - bx);
  }

  /* the grid (bx, by) can be seen from the grid (ax, ay) if and only if
   * there is an integer j in [0, longer_abs - 1] such that the grid
   * (ax
   *  + longer_dx * i
   *  + shorter_dx * ((shorter_abs * i + j) / longer_abs),
   *  ay
   *  + longer_dy * i
   *  + shorter_dy * ((shorter_abs * i + j) / longer_abs)) does not
   * block the line of sight for every integer i in [1, longer_abs - 1]
   */
  blocked_j_low = -1;
  blocked_j_high = longer_abs;
  for (i = 1; i < longer_abs; i++)
  {
    x = ax
      + longer_dx * i
      + shorter_dx * ((shorter_abs * i) / longer_abs);
    y = ay
      + longer_dy * i
      + shorter_dy * ((shorter_abs * i) / longer_abs);
    j0 = (shorter_abs * i) % longer_abs;
    if (j0 == 0)
    {
      if (grid_blocks_los(wp, x, y) != 0)
        return 0;
    }
    else
    {
      if (grid_blocks_los(wp, x, y) != 0)
      {
        if (blocked_j_low < longer_abs - j0 - 1)
          blocked_j_low = longer_abs - j0 - 1;
      }
      if (grid_blocks_los(wp, x + shorter_dx, y + shorter_dy) != 0)
      {
        if (blocked_j_high > longer_abs - j0)
          blocked_j_high = longer_abs - j0;
      }
      if (blocked_j_low + 1 >= blocked_j_high)
        return 0;
    }
  }

  return 1;
}
