/* $Id: main.c,v 1.23 2010/03/05 08:47:19 oohara Exp $ */

#include <stdio.h>
/* srand */
#include <stdlib.h>
/* time */
#include <time.h>

#include "world.h"
#include "creature.h"
#include "dungeon.h"
#include "loop.h"
#include "object.h"
#include "save.h"

static int build_world(world *wp);

static int
build_world(world *wp)
{
  int i;
  int n;
  int x;
  int y;
  creature *who = NULL;
  object *what = NULL;

  who = creature_new();
  if (who == NULL)
  {
    fprintf(stderr, "build_world: creature_new 0 failed \n");
    return 1;
  }
  who->type = 0;
  who->x = wp->size_x / 2;
  who->y = wp->size_y / 2;
  who->wait = 0;
  who->hp = 99;
  n = add_creature(wp, who);
  if (n < 0)
  {
    fprintf(stderr, "build_world: add_creature 0 failed \n");
    return 1;
  }
  wp->player_id = n;
  wp->camera_x = who->x;
  wp->camera_y = who->y;
  wp->cursor_x = who->x;
  wp->cursor_y = who->y;

  for (i = 0; i < 18; i++)
  {
    who = creature_new();
    if (who == NULL)
    {
      fprintf(stderr, "build_world: creature_new %d failed \n", i + 1);
      return 1;
    }
    who->type = 1;
    while (1 == 1)
    { 
      who->x = rand() % wp->size_x;
      who->y = rand() % wp->size_y;
      if ((!grid_blocks_creature(wp, who->x, who->y))
          && (!grid_has_creature(wp, who->x, who->y)))
        break;
    }
    who->wait = 0;
    who->hp = 1;
    n = add_creature(wp, who);
    if (n < 0)
    {
      fprintf(stderr, "build_world: add_creature %d failed \n", i + 1);
      return 1;
    }
  }

  for (x = 0; x < wp->size_x; x++)
  {
    for (y = 0; y < wp->size_y; y++)
    {
      if ((x == 0) || (x == wp->size_x - 1)
          || (y == 0) || (y == wp->size_y - 1))
        wp->grid[x][y] = 1;
      else
        wp->grid[x][y] = 0;
    }
  }

  for (i = 0; i < 250; i++)
  {
    while (1 == 1)
    {
      x = rand() % wp->size_x;
      y = rand() % wp->size_y;
      if ((!grid_blocks_creature(wp, x, y))
          && (!grid_has_creature(wp, x, y)))
        break;
    }
    wp->grid[x][y] = 1;
  }

  for (i = 0; i < 8; i++)
  {
    what = object_new();
    if (what == NULL)
    {
      fprintf(stderr, "build_world: object_new %d failed\n", i);
      return 1;
    }
    what->type = i % 2;
    while (1 == 1)
    {
      what->x = rand() % wp->size_x;
      what->y = rand() % wp->size_y;
      if ((!grid_blocks_creature(wp, what->x, what->y))
          && (!grid_has_creature(wp, what->x, what->y)))
        break;
    }
    what->quantity = 1;
    n = add_object(wp, what);
    if (n < 0)
    {
      fprintf(stderr, "build_world: add_object %d failed\n", i);
      return 1;
    }
  }

  return 0;
}

int
main(int argc, char *argv[])
{
  world *wp = NULL;

  srand((unsigned int) time(NULL));

  wp = world_new();
  if (wp == NULL)
  {
    fprintf(stderr, "main: world_new failed\n");
    return 1;
  }

  if (load_game(wp) != 0)
  {
    world_reset_game(wp);
    build_world(wp);
  }
  main_loop(wp);

  return 0;
}
