/* $Id: matrix.c,v 1.5 2010/03/03 22:50:34 oohara Exp $ */

#include <stdio.h>
/* malloc */
#include <stdlib.h>

#include "matrix.h"

int **
matrix2_new(int size_x, int size_y)
{
  int x;
  int **p = NULL;

  if (size_x <= 0)
  {
    fprintf(stderr, "matrix2_new: size_x is non-positive (%d)\n", size_x);
    return NULL;
  }
  if (size_y <= 0)
  {
    fprintf(stderr, "matrix2_new: size_y is non-positive (%d)\n", size_y);
    return NULL;
  }

  p = (int **) malloc(sizeof(int *) * size_x);
  if (p == NULL)
  {
    fprintf(stderr, "matrix2_new: malloc(p) failed\n");
    return NULL;
  }
  for (x = 0; x < size_x; x++)
    p[x] = NULL;

  for (x = 0; x < size_x; x++)
  {
    p[x] = (int *) malloc(sizeof(int) * size_y);
    if (p[x] == NULL)
    {
      fprintf(stderr, "matrix2_new: malloc(p[%d]) failed\n", x);
      matrix2_delete(p, size_x, size_y);
      p = NULL;
      return NULL;
    }
  }

  return p;
}

void
matrix2_delete(int **p, int size_x, int size_y)
{
  int x;
  if (p == NULL)
    return;

  for (x = 0; x < size_x; x++)
  {
    if (p[x] != NULL)
    {
      free(p[x]);
      p[x] = NULL;
    }
  }

  free(p);
  p = NULL;
}
