/* $Id: monster.c,v 1.15 2010/03/03 06:03:56 oohara Exp $ */

#include <stdio.h>
/* rand, abs */
#include <stdlib.h>

#include "world.h"
#include "action.h"
#include "dungeon.h"

#include "monster.h"

int
action_decide_monster(world *wp, int creature_id)
{
  int i;
  creature *who = NULL;
  creature *player = NULL;

  if (wp == NULL)
  {
    fprintf(stderr, "action_decide_monster: wp is NULL\n");
    return 1;
  }
  if ((creature_id < 0) || (creature_id >= wp->cr_size))
  {
    fprintf(stderr, "action_decide_monster: strange creature_id (%d)\n",
            creature_id);
    return 1;
  }
  if (creature_id == wp->player_id)
  {
    fprintf(stderr, "action_decide_monster: creature %d is player\n",
            creature_id);
    return 1;
  }
  if (creature_is_dead(wp, creature_id))
  {
    fprintf(stderr, "action_decide_monster: creature %d is dead\n",
            creature_id);
    return 1;
  }

  who = wp->cr[creature_id];
  if (creature_is_dead(wp, wp->player_id))
  {
    who->act[0] = ACTION_STAY;
    return 0;
  }
  player = wp->cr[wp->player_id];

  who->act[0] = ACTION_WALK;
  if (who->x < player->x)
    who->act[1] = 1;
  else if (who->x > player->x)
    who->act[1] = -1;
  else
    who->act[1] = 0;
  if (who->y < player->y)
    who->act[2] = 1;
  else if (who->y > player->y)
    who->act[2] = -1;
  else
    who->act[2] = 0;

  if ((abs(who->x - player->x) > 1) || (abs(who->y - player->y) > 1))
  {    
    if ((abs(who->x - player->x) > abs(who->y - player->y) + 1)
        && (rand() % 2 == 0))
      who->act[2] = (rand() % 3) - 1;
    if ((abs(who->x - player->x) + 1 < abs(who->y - player->y))
        && (rand() % 2 == 0))
      who->act[1] = (rand() % 3) - 1;
  }

  for (i = 0; i < wp->cr_size; i++)
  {
    if (wp->cr[i] == NULL)
      continue;
    if ((i == who->id) || (i == player->id))
      continue;
    if ((wp->cr[i]->x == who->x + who->act[1])
        && (wp->cr[i]->y == who->y + who->act[2]))
    {
      who->act[0] = ACTION_STAY;
      return 0;
    }
  }

  if (!action_check(wp, who->id, who->act))
  {
    who->act[0] = ACTION_STAY;
    return 0;
  }

  return 0;
}

