/* $Id: world.h,v 1.24 2010/03/05 00:35:41 oohara Exp $ */

#ifndef __WORLD_H__
#define __WORLD_H__

#include <curses.h>

#include "creature.h"
#include "list-int.h"
#include "object.h"

struct _world
{
  /* should be saved */
  int cr_size;
  creature **cr;
  list_int *turn_order;
  int obj_size;
  object **obj;
  int size_x;
  int size_y;
  int **grid;
  int player_id;
  int camera_x;
  int camera_y;
  int **inv;
  /* not saved */
  WINDOW *scr;
  int *mode;
  int cursor_x;
  int cursor_y;
  int log_size;
  char **log;
  int log_head;
};
typedef struct _world world;

world *world_new(void);
void world_delete(world *wp);
void world_reset_game(world *wp);
int world_expand_cr(world *wp);
int world_expand_obj(world *wp);

#endif /* not __WORLD_H__ */
